package bus

import (
	"context"
	"fmt"
	"queencount/db"
	"queencount/db/model"
	"queencount/db/repo"
	"time"

	"go.mongodb.org/mongo-driver/bson"
	"go.mongodb.org/mongo-driver/bson/primitive"
)

func AssetCountAction(actionName string, req *model.AssetEvent) {

	dbcxt := &repo.RepoSession{Client: db.MongoClient, Ctx: context.Background()}

	fmt.Printf("action req data =>\n%#v\n", *req)

	var in model.AssetCount

	var databaseDoc model.Database

	dbId, _ := primitive.ObjectIDFromHex(req.DbId)
	param := &repo.DocSearchOptions{
		// Db: "queentree",
		CollectName: repo.CollectionDatabase,
		Query:       map[string]interface{}{"_id": dbId},
		Project:     []string{"_id", "name"},
		// Sort: bson.M{},
	}

	// 获取对应资产库 - 数据库
	repo.RepoSeachDoc(dbcxt, param, &databaseDoc)
	fmt.Printf("action database data =>\n%#v\n", databaseDoc)

	// 跨库查询 对应的 assetcount文档
	param1 := &repo.DocSearchOptions{
		Db:          databaseDoc.Name,
		CollectName: repo.CollectionAssetCount,
		Query:       map[string]interface{}{"defId": req.DefId},
		Project:     []string{"_id", "count"},
		Sort:        bson.M{"createTime": -1},
	}
	// 拿到最新一条数据 获取count
	var countData model.AssetCount
	repo.RepoSeachDoc(dbcxt, param1, &countData)

	fmt.Printf("action assetCount data =>\n%#v\n", countData)

	// 统计新增
	in.DefId = req.DefId
	if actionName == "add" {
		in.Count = countData.Count + 1

	}
	if actionName == "remove" {
		in.Count = countData.Count - 1

	}

	in.CreateTime = time.Now()
	// ???本地测试新增不生效
	id, _ := repo.RepoDbAddDoc(dbcxt, databaseDoc.Name, repo.CollectionAssetCount, &in)
	fmt.Printf("action add id =>\n%#v\n", id)
	fmt.Println("----------------------------------")
	fmt.Printf("action add data =>\n%#v\n", in)

}
